#ifndef TTL_IO_FORM_H
#define TTL_IO_FORM_H

#include <QWidget>
#include <QCheckBox>
#include <QComboBox>
#include <QCloseEvent>

namespace Ui {
    class TTL_IO_Form;
}

class TTL_IO_Form : public QWidget
{
    Q_OBJECT

public:
    explicit TTL_IO_Form(QWidget *parent = 0, Qt::WindowFlags fl = 0 );
    ~TTL_IO_Form();
    // sub fuction:
    void ttl_io_config_read();
    void ttl_io_point_read();
    void ttl_io_rename(int,int);

public:
    int ttl_io_timer;
    bool is_fomr_started;


protected:
    void timerEvent ( QTimerEvent *event);
    void closeEvent ( QCloseEvent *event );
    void showEvent ( QShowEvent * );

private slots:
      void on_Debounce0_comboBox_currentIndexChanged(int index);

      void on_Debounce1_comboBox_currentIndexChanged(int index);

      void on_IOConfig0_comboBox_currentIndexChanged(int index);

      void on_IOConfig1_comboBox_currentIndexChanged(int index);

      void on_Port00_checkBox_clicked(bool checked);

      void on_Port01_checkBox_clicked(bool checked);

      void on_Port02_checkBox_clicked(bool checked);

      void on_Port03_checkBox_clicked(bool checked);

      void on_Port04_checkBox_clicked(bool checked);

      void on_Port05_checkBox_clicked(bool checked);

      void on_Port06_checkBox_clicked(bool checked);

      void on_Port07_checkBox_clicked(bool checked);


      void on_Port10_checkBox_clicked(bool checked);

      void on_Port11_checkBox_clicked(bool checked);

      void on_Port12_checkBox_clicked(bool checked);

      void on_Port13_checkBox_clicked(bool checked);

      void on_Port14_checkBox_clicked(bool checked);

      void on_Port15_checkBox_clicked(bool checked);

      void on_Port16_checkBox_clicked(bool checked);

      void on_Port17_checkBox_clicked(bool checked);


private:
    Ui::TTL_IO_Form *ui;
    QCheckBox *Port0_checkBox[8];
    QCheckBox *Port1_checkBox[8];
    QComboBox *Debounce_comboBox[2];
    QComboBox *IOConfig_comboBox[2];
};

#endif // TTL_IO_FORM_H
